#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "BOARD.h"   

enum {
    FIRST, ISINT, ISNEG, ISFRAC
};

int isNumber(char* token)
{
    int state = FIRST;
    char * this_char = token;
    while (1) {
        switch (state) {
        case FIRST:
            switch (*this_char) {
            case '-':
                state = ISNEG;
                break;
            case '.':
                state = ISFRAC;
                break;
            case '0'...'9':
                state = ISINT;
                break;
            default: return FALSE;
            }
            break;
            
        case ISNEG:
            switch (*this_char) {
            case '.':
                state = ISFRAC;
                break;
            case '0'...'9':
                break; //no transition necessary!
            case '\0':
                return TRUE;
            default:
                return FALSE;
            }
            break;
            
        case ISINT:
            switch (*this_char) {
            case '0'...'9':
                break; //no transition necessary!
            case '.':
                state = ISFRAC;
                break;
            case '\0':
                return TRUE;
            default:
                return FALSE;
            }
            break;

        case ISFRAC:
            switch (*this_char) {
            case '0'...'9':
                break; //no transition necessary!
            case '\0':
                return TRUE;
            default:
                return FALSE;
            }
            break;
            
        }
        this_char++;
    }
}

int main(void)
{
    BOARD_Init();

    char * test_strings[] = {
        "3.14159",
        "--3148",
        "-.000",
        "12.5%",
        "192.168.1.1",
        NULL
    };
    int i = 0; 
    while(test_strings[i]){
        printf("%d : %s\n", isNumber(test_strings[i]),test_strings[i]);
        i++;
    }
    
    return 0;
}

