//standard libraries
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// User libraries
#include "BOARD.h"  //<<include BOARD.h before xc.h and plib.h unless you want lots of warnings!

// Microchip libraries
#include <xc.h>
#include <plib.h>

void InitializeLEDsToPattern(char x)
{
    //Set LEDs to outputs:
    TRISE = 0x00;
    //set them to off by default:
    LATE = x;
}

#define INIT_LEDS_TO_PATTERN(x) {LATE = 0x00; TRISE = x;}

int main(void)
{
    BOARD_Init();

#define z 0xDEADBEEF
    const int y = 0xBEEFDEAD;
    //test macro
    int Z = z;
    //test const
    int Y = y;
    
    //Initialize LEDs via function:
    InitializeLEDsToPattern(0b00110011);

    //Initialize LEDs via macro:
    INIT_LEDS_TO_PATTERN(0b11001100);


    //
    //
    //
    //Look at some BOARD.h macros:

    //Read switch 1:
    char switch1_state;

    //the next 4 lines all do the same thing:

    //hard to read:
    switch1_state = (PORTD >> 8) & 1; //Nothing fancy
    switch1_state = PORTDbits.RD8; //Use xc.h's union notation

    //Easy to read:
    switch1_state = SWITCH_STATES() & 1; //Use BOARD.h's macro for all switches
    switch1_state = SW1; //Use BOARD.h's macro for one switch


#define FP_DELTA 0.001
#define EQUAL_WITHIN_DELTA(x, y) ((x - y) < FP_DELTA) && ((y - x) < FP_DELTA)


    float a = 3.000001;
    int b = 3;
    if (EQUAL_WITHIN_DELTA(a, b)) {
        printf("X and Y are equal!\n");
    }

#define  SQR(x) (x*x)

    printf("5+2 = 7, 7*7 = %d", SQR(5 + 2));

    //This macro doesn't work!
    /*
#define max(a,b) if(a>b) { \
        return a; \
       } else {return b;}
    
    printf("%d\n", max(4,5));
*/
    while (1);
    return 0;
}


